# Extra Scoreboard stuff
execute unless score @s Capacitor_Charge matches 0.. run scoreboard players set @s Capacitor_Charge 0
execute if score @s Capacitor_Charge matches 1281.. run scoreboard players set @s Capacitor_Charge 1280

# Determining number of inputs and outputs
execute at @s store result score @s input_count if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1},tag=!charged,distance=...80]
execute at @s store result score @s charged_input_count if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1},tag=charged,distance=...80]
scoreboard players operation @s charged_input_count *= const8 capacitor_multiply
scoreboard players operation @s charged_input_count *= const2 capacitor_multiply
scoreboard players operation @s input_count += @s charged_input_count
execute at @s unless predicate copperwire:functional_redstone store result score @s output_count if entity @e[type=marker,tag=copper_wiring,tag=wire,distance=1.20..1.30]
execute at @s if block ~ ~ ~ #copperwire:weathered run scoreboard players operation @s input_count *= const2 capacitor_multiply
execute at @s if block ~ ~ ~ #copperwire:weathered run scoreboard players operation @s output_count *= const2 capacitor_multiply
execute at @s if block ~ ~ ~ #copperwire:exposed run scoreboard players operation @s input_count *= const4 capacitor_multiply
execute at @s if block ~ ~ ~ #copperwire:exposed run scoreboard players operation @s output_count *= const4 capacitor_multiply
execute at @s if block ~ ~ ~ #copperwire:no_oxidation run scoreboard players operation @s input_count *= const8 capacitor_multiply
execute at @s if block ~ ~ ~ #copperwire:no_oxidation run scoreboard players operation @s output_count *= const8 capacitor_multiply

# Changing power state
execute at @s if score @s Capacitor_Charge >= @s output_count if score @s input_count >= @s output_count unless predicate copperwire:functional_redstone run scoreboard players set @s powered_state 1
execute at @s if score @s Capacitor_Charge >= @s output_count if score @s input_count matches 0 unless predicate copperwire:functional_redstone run scoreboard players set @s powered_state 1
execute if score @s Capacitor_Charge matches 1280.. unless predicate copperwire:functional_redstone run scoreboard players set @s powered_state 1
execute if score @s Capacitor_Charge < @s output_count unless score @s input_count >= @s output_count run scoreboard players set @s powered_state 0
execute if predicate copperwire:functional_redstone run scoreboard players set @s powered_state 0

# Capacitor-Specific stuff
execute if score @s Capacitor_Charge matches ..1280 run scoreboard players operation @s Capacitor_Charge += @s input_count
execute as @s[scores={powered_state=1}] if score @s Capacitor_Charge >= @s output_count run scoreboard players operation @s Capacitor_Charge -= @s output_count
execute if score @s Capacitor_Charge matches 0 run data modify entity @s block_state.Name set value "minecraft:air"
execute if score @s Capacitor_Charge matches 1..1280 if score @s Capacitor_Charge > @s output_count run data modify entity @s block_state.Name set value "minecraft:purple_concrete"
execute if score @s Capacitor_Charge matches 1..1280 store result entity @s transformation.scale[1] float 0.000732421875 run scoreboard players get @s Capacitor_Charge

# Wires power on
execute as @s[scores={powered_state=1}] at @s run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0},distance=1.20..1.30] powered_state 1