# Wire Functions
execute as @a at @s anchored eyes run function copperwire:summon/looking
execute as @e[type=marker,tag=copper_wiring,tag=wire] at @s if entity @e[type=block_display,tag=wire_insulation,distance=...4] positioned ~ ~1 ~ if predicate copperwire:lightning run setblock ~ ~ ~ light[level=0]
execute as @e[type=marker,tag=copper_wiring,tag=wire] at @s unless predicate copperwire:wire_scores run function copperwire:directional_wire
execute as @e[type=marker,tag=copper_wiring,tag=wire] at @s if block ~ ~ ~ lightning_rod positioned ^ ^ ^1 unless entity @e[type=marker,tag=copper_wiring,distance=...01] run function copperwire:summon/wire
execute as @e[type=marker,tag=copper_wiring,tag=wire] at @s if score .wire_speed wire_speed matches 0 if block ~ ~ ~ lightning_rod run function copperwire:wire
execute as @e[type=marker,tag=copper_wiring,tag=wire] at @s if score .wire_speed wire_speed matches 1 if block ~ ~ ~ lightning_rod positioned ^ ^ ^-1 if block ~ ~ ~ lightning_rod unless score @s powered_state = @n[tag=copper_wiring,tag=wire,distance=...001] powered_state run function copperwire:wire
execute as @e[type=marker,tag=copper_wiring,tag=wire] at @s if score .wire_speed wire_speed matches 1 if block ~ ~ ~ lightning_rod positioned ^ ^ ^-1 if block ~ ~ ~ lightning_rod if score @s powered_state = @n[tag=copper_wiring,tag=wire,distance=...001] powered_state run function copperwire:wire

# Block Functions
execute as @e[tag=copper_wiring] at @s if block ~ ~ ~ #copperwire:all_copper run function copperwire:summon/block
execute as @e[type=marker,tag=copper_wiring,tag=wire] at @s if score .wire_speed wire_speed matches 1 if block ~ ~ ~ lightning_rod positioned ^ ^ ^-1 unless block ~ ~ ~ lightning_rod run function copperwire:wire
execute as @e[type=marker,tag=copper_wiring,tag=split_wire_block] at @s if block ~ ~ ~ #copperwire:copper_block run function copperwire:split_wire
execute as @e[type=marker,tag=copper_wiring,tag=cut_wire_block] at @s if block ~ ~ ~ #copperwire:cut_copper run function copperwire:cut_wire
execute as @e[type=marker,tag=copper_wiring,tag=passthrough_wire_block] at @s if block ~ ~ ~ #copperwire:chiseled_copper run function copperwire:passthrough_wire
execute as @e[type=block_display,tag=copper_wiring,tag=capacitor_wire_block] at @s if block ~ ~ ~ #copperwire:copper_grate run function copperwire:capacitor_wire
execute as @e[type=block_display,tag=copper_wiring,tag=tesla_core] at @s if block ~ ~ ~ heavy_core run function copperwire:tesla_core

# Capacitor-Specific Functions
execute as @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1,Capacitor_Charge=0}] at @s if block ^ ^ ^1 #copperwire:chiseled_copper if block ^ ^ ^1 #copperwire:no_oxidation run scoreboard players add @s Capacitor_Charge 1
execute as @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1,Capacitor_Charge=..1}] at @s if block ^ ^ ^1 #copperwire:chiseled_copper if block ^ ^ ^1 #copperwire:exposed run scoreboard players add @s Capacitor_Charge 1
execute as @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1,Capacitor_Charge=..3}] at @s if block ^ ^ ^1 #copperwire:chiseled_copper if block ^ ^ ^1 #copperwire:weathered run scoreboard players add @s Capacitor_Charge 1
execute as @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1,Capacitor_Charge=..7}] at @s if block ^ ^ ^1 #copperwire:chiseled_copper if block ^ ^ ^1 #copperwire:oxidized run scoreboard players add @s Capacitor_Charge 1
execute as @e[type=marker,tag=copper_wiring,tag=wire,scores={Capacitor_Charge=1..8}] at @s unless block ^ ^ ^1 #copperwire:chiseled_copper run scoreboard players set @s Capacitor_Charge 0
execute as @e[type=marker,tag=copper_wiring,tag=wire] at @s if score @s powered_state matches 0 if score @s Capacitor_Charge matches 1.. run scoreboard players remove @s Capacitor_Charge 1
execute as @e[type=marker,tag=copper_wiring,tag=wire] at @s unless score @s Capacitor_Charge matches 0..8 run scoreboard players set @s Capacitor_Charge 0
execute as @e[type=marker,tag=copper_wiring,tag=wire] at @s unless block ~ ~ ~ lightning_rod run scoreboard players set @s powered_state 0

# Tesla-Specific Functions
execute as @e[type=block_display,tag=copper_wiring,tag=tesla_core,tag=powered] at @s unless block ~ ~ ~ heavy_core run stopsound @a block minecraft:block.beacon.ambient
execute as @e[type=block_display,tag=copper_wiring,tag=tesla_core,tag=powered] at @s unless block ~ ~ ~ heavy_core run stopsound @a block minecraft:block.beacon.activate
execute as @e[type=block_display,tag=copper_wiring,tag=tesla_core,tag=powered] at @s unless block ~ ~ ~ heavy_core run playsound minecraft:block.beacon.deactivate block @a ~ ~ ~ 2 .5

# Damaging players/mobs from shock damage and particles
execute as @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1},tag=!charged] at @s if block ~ ~ ~ lightning_rod[waterlogged=true] positioned ^ ^ ^-.25 unless entity @e[type=block_display,tag=wire_insulation,distance=...25] run execute as @e[predicate=copperwire:attract_electricity,distance=..1.575] at @s if predicate copperwire:waterlogged run damage @s 1.5 lightning_bolt
execute as @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1},tag=!charged] at @s if block ~ ~ ~ lightning_rod[waterlogged=true] positioned ^ ^ ^-.25 if entity @e[type=block_display,tag=wire_insulation,distance=...25] positioned ^ ^ ^1 run execute as @e[predicate=copperwire:attract_electricity,distance=...575] at @s if predicate copperwire:waterlogged run damage @s 1.5 lightning_bolt
execute as @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1},tag=!charged] at @s positioned ^ ^ ^-.25 unless entity @e[type=block_display,tag=wire_insulation,distance=...25] run execute as @e[predicate=copperwire:attract_electricity,predicate=!copperwire:shock_prevent_damage,distance=...8] at @s run damage @s 1.5 lightning_bolt
execute as @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1},tag=!charged] at @s positioned ^ ^ ^.30 if block ~ ~ ~ air run execute as @e[predicate=copperwire:attract_electricity,predicate=!copperwire:shock_prevent_damage,distance=...6] at @s run damage @s 1.5 lightning_bolt
execute as @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1}] at @s positioned ^ ^ ^.30 if block ~ ~ ~ #copperwire:no_fill_insulation_blocks run particle electric_spark ^ ^ ^.05 0.01 0.01 0.01 .25 3

# Wire insulation scaling and positioning based on blocks around
execute as @e[type=marker,tag=copper_wiring,tag=wire] at @s if entity @e[type=block_display,tag=wire_insulation,distance=...4] run tp @e[type=block_display,tag=wire_insulation,distance=...4] ^ ^ ^-.25 ~ ~
execute as @e[type=block_display,tag=wire_insulation,nbt={block_state:{Name:"minecraft:air"}}] run data merge entity @s {block_state:{Name:"minecraft:clay"}}
execute as @e[type=block_display,tag=wire_insulation,nbt=!{transformation:{translation:[-.1875f,-.1875f,-.4375f],scale:[.375f,.375f,.875f]}}] at @s if block ^ ^ ^-1 #copperwire:no_fill_insulation_blocks if block ^ ^ ^1 #copperwire:no_fill_insulation_blocks run data merge entity @s {transformation:{translation:[-.1875f,-.1875f,-.4375f],scale:[.375f,.375f,.875f]}}
execute as @e[type=block_display,tag=wire_insulation,nbt=!{transformation:{translation:[-.1875f,-.1875f,-.4374f],scale:[.375f,.375f,.9377f]}}] at @s if block ^ ^ ^-1 #copperwire:no_fill_insulation_blocks unless block ^ ^ ^1 #copperwire:no_fill_insulation_blocks run data merge entity @s {transformation:{translation:[-.1875f,-.1875f,-.4374f],scale:[.375f,.375f,.9377f]}}
execute as @e[type=block_display,tag=wire_insulation,nbt=!{transformation:{translation:[-.1875f,-.1875f,-.5001f],scale:[.375f,.375f,.9375f]}}] at @s unless block ^ ^ ^-1 #copperwire:no_fill_insulation_blocks if block ^ ^ ^1 #copperwire:no_fill_insulation_blocks run data merge entity @s {transformation:{translation:[-.1875f,-.1875f,-.5001f],scale:[.375f,.375f,.9375f]}}
execute as @e[type=block_display,tag=wire_insulation,nbt=!{transformation:{translation:[-.1875f,-.1875f,-.5001f],scale:[.375f,.375f,1.0002f]}}] at @s unless block ^ ^ ^-1 #copperwire:no_fill_insulation_blocks unless block ^ ^ ^1 #copperwire:no_fill_insulation_blocks run data merge entity @s {transformation:{translation:[-.1875f,-.1875f,-.5001f],scale:[.375f,.375f,1.0002f]}}
execute as @e[type=marker,tag=copper_wiring,tag=wire] at @s align xyz positioned ~.5 ~.25 ~.5 unless entity @e[type=block_display,tag=wire_insulation,distance=...4] if entity @e[type=player,distance=..5,nbt={SelectedItem:{id:"minecraft:clay_ball"}},scores={copperwire_sneaking=0}] unless entity @e[type=interaction,tag=copper_wiring,distance=...375] run function copperwire:summon/interaction
execute as @e[type=marker,tag=copper_wiring,tag=wire] at @s align xyz positioned ~.5 ~.25 ~.5 if entity @e[type=block_display,tag=wire_insulation,distance=...4,nbt=!{brightness:{sky:10,block:15}}] if entity @e[type=player,distance=..5,nbt={SelectedItem:{id:"minecraft:glow_ink_sac"}},scores={copperwire_sneaking=0}] unless entity @e[type=interaction,tag=copper_wiring,distance=...375] run function copperwire:summon/interaction
execute as @e[type=marker,tag=copper_wiring,tag=wire] at @s align xyz positioned ~.5 ~.25 ~.5 if entity @e[type=block_display,tag=wire_insulation,distance=...4] if entity @e[type=player,distance=..5,nbt={SelectedItem:{id:"minecraft:shears"}},scores={copperwire_sneaking=0}] unless entity @e[type=interaction,tag=copper_wiring,distance=...375] run function copperwire:summon/interaction
execute as @e[type=marker,tag=copper_wiring,tag=wire] at @s align xyz positioned ~.5 ~.25 ~.5 if entity @e[type=block_display,tag=wire_insulation,distance=...4,nbt={block_state:{Name:"minecraft:clay"}}] if entity @e[type=player,distance=..5,predicate=copperwire:interactable,scores={copperwire_sneaking=0}] unless entity @e[type=interaction,tag=copper_wiring,distance=...375] run function copperwire:summon/interaction

# Kill commands and others
execute as @e[predicate=copperwire:kill_predicate] at @s run kill @s
execute as @e[type=block_display,tag=wire_insulation] at @s unless entity @e[type=marker,tag=copper_wiring,tag=wire,distance=...4] positioned ~ ~1 ~ if block ~ ~ ~ light[level=0] run setblock ~ ~ ~ air
execute as @e[type=block_display,tag=wire_insulation] at @s unless entity @e[type=marker,tag=copper_wiring,tag=wire,distance=...3] run kill @s
execute as @e[type=interaction,tag=copper_wiring,tag=xz] at @s unless entity @e[type=marker,tag=copper_wiring,tag=wire,distance=...3] run kill @s
execute as @e[type=interaction,tag=copper_wiring,tag=y] at @s align xyz positioned ~.5 ~.5 ~.5 unless entity @e[type=marker,tag=copper_wiring,tag=wire,distance=...3] run kill @s
execute as @e[type=interaction,tag=copper_wiring] at @s unless entity @e[type=block_display,tag=wire_insulation,distance=...5] unless entity @e[type=player,distance=..5,nbt={SelectedItem:{id:"minecraft:clay_ball"}},scores={copperwire_sneaking=0}] run kill @s
execute as @e[type=interaction,tag=copper_wiring] at @s if entity @e[type=block_display,tag=wire_insulation,distance=...5] unless entity @e[type=player,distance=..5,predicate=copperwire:interactable,scores={copperwire_sneaking=0}] unless entity @e[type=player,distance=..5,nbt={SelectedItem:{id:"minecraft:shears"}},scores={copperwire_sneaking=0}] unless entity @e[type=player,distance=..5,nbt={SelectedItem:{id:"minecraft:glow_ink_sac"}},scores={copperwire_sneaking=0}] run kill @s
execute as @e[type=interaction,tag=copper_wiring] at @s if entity @e[type=block_display,tag=wire_insulation,distance=...5,nbt=!{block_state:{Name:"minecraft:clay"}}] unless entity @e[type=player,distance=..5,nbt={SelectedItem:{id:"minecraft:shears"}},scores={copperwire_sneaking=0}] unless entity @e[type=player,distance=..5,nbt={SelectedItem:{id:"minecraft:glow_ink_sac"}},scores={copperwire_sneaking=0}] run kill @s
execute as @e[type=interaction,tag=copper_wiring] at @s if entity @e[type=block_display,tag=wire_insulation,distance=...5,nbt={brightness:{sky:10,block:15}}] unless entity @e[type=player,distance=..5,nbt={SelectedItem:{id:"minecraft:glow_ink_sac"}},scores={copperwire_sneaking=1..}] unless entity @e[type=player,distance=..5,predicate=copperwire:interactable,scores={copperwire_sneaking=0}] unless entity @e[type=player,distance=..5,nbt={SelectedItem:{id:"minecraft:shears"}},scores={copperwire_sneaking=0}] run kill @s
scoreboard players set @a[scores={copperwire_sneaking=1..}] copperwire_sneaking 0
