# Generate random numbers
execute as @s store result storage tesla_raycast x float .01 run random value -15..15
execute as @s store result storage tesla_raycast y float .01 run random value -15..15
execute as @s store result storage tesla_raycast z float .01 run random value 5..10
execute as @s store result storage tesla_raycast x2 int 1 run random value -10..10
execute as @s store result storage tesla_raycast y2 int 1 run random value -10..10
execute as @s store result storage tesla_raycast z2 int 1 run random value -10..10

# Damage, particles, and main stuff
execute as @s[scores={counter=10}] run particle electric_spark ~ ~ ~ 0.01 0.01 0.01 0.025 1
execute as @s[scores={counter=10}] positioned ^ ^ ^ run damage @n[predicate=copperwire:attract_electricity,predicate=!copperwire:shock_prevent_damage,distance=...5] 1.5 lightning_bolt
$execute as @s if entity @e[sort=random,limit=1,predicate=copperwire:attract_electricity,distance=..5] facing entity @n[predicate=copperwire:attract_electricity,distance=..5] feet positioned ^$(x) ^$(y) ^$(z) unless entity @n[predicate=copperwire:attract_electricity,distance=...25] if block ~ ~ ~ #copperwire:tesla_ignore run return run function copperwire:tesla_raycast with storage tesla_raycast
$execute as @s if entity @s[distance=..5] unless entity @e[sort=random,limit=1,predicate=copperwire:attract_electricity,distance=..5] unless entity @e[sort=random,limit=1,predicate=copperwire:attract_electricity,distance=..5] facing ~$(x2) ~$(y2) ~$(z2) positioned ^$(x) ^-.025 ^$(z) if block ~ ~ ~ #copperwire:tesla_ignore run return run function copperwire:tesla_raycast with storage tesla_raycast

# Power states of wires
execute as @s[scores={counter=10}] positioned ^ ^ ^ run scoreboard players set @n[type=marker,tag=copper_wiring,tag=wire,distance=...5] powered_state 1
execute as @s[scores={counter=10}] positioned ^ ^ ^ run tag @n[type=marker,tag=copper_wiring,tag=wire,distance=...5] add powered_state

# Counting score stuff
execute as @s[scores={counter=..10}] run scoreboard players add @s counter 1
execute as @s[scores={counter=11..}] run scoreboard players set @s counter 1
execute as @s unless entity @s[scores={counter=0..}] run scoreboard players set @s counter 0