# Determining number of inputs and outputs
execute at @s store result score @s input_count if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1},tag=!charged,distance=...80]
execute at @s store result score @s charged_input_count if entity @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=1},tag=charged,distance=...80]
scoreboard players operation @s charged_input_count *= const8 capacitor_multiply
scoreboard players operation @s charged_input_count *= const2 capacitor_multiply
scoreboard players operation @s input_count += @s charged_input_count
execute at @s unless predicate copperwire:functional_redstone store result score @s output_count if entity @e[type=marker,tag=copper_wiring,tag=wire,distance=1.20..1.30]
execute at @s if block ~ ~ ~ #copperwire:exposed run scoreboard players operation @s output_count *= const2 capacitor_multiply
execute at @s if block ~ ~ ~ #copperwire:weathered run scoreboard players operation @s output_count *= const4 capacitor_multiply
execute at @s if block ~ ~ ~ #copperwire:oxidized run scoreboard players operation @s output_count *= const8 capacitor_multiply

# Changing power state
execute if score @s input_count = @s output_count unless predicate copperwire:functional_redstone run scoreboard players set @s powered_state 1
execute unless score @s input_count = @s output_count run scoreboard players set @s powered_state 0
execute if predicate copperwire:functional_redstone run scoreboard players set @s powered_state 0

# Wires power on
execute as @s[scores={powered_state=1}] at @s run scoreboard players set @e[type=marker,tag=copper_wiring,tag=wire,scores={powered_state=0},distance=1.20..1.30] powered_state 1